=== src/third_party/CMakeLists.txt ===

if (NOT MINIZIP_STATIC_LIBRARIES)
  wl_library(third_party_minizip
    THIRD_PARTY
    SRCS
      minizip/ioapi.h
      minizip/unzip.cc
      minizip/unzip.h
      minizip/zip.h
    USES_ZLIB
  )
  message(STATUS "Using embedded minizip libraries")
endif()

wl_library(third_party_sha1
  THIRD_PARTY
  SRCS
    sha1/sha1.cc
    sha1/sha1.h
)

wl_library(third_party_eris
  THIRD_PARTY
  C_LIBRARY
  SRCS
    eris/eris.c
    eris/eris.h
    eris/lapi.c
    eris/lapi.h
    eris/lauxlib.c
    eris/lauxlib.h
    eris/lbaselib.c
    eris/lbitlib.c
    eris/lcode.c
    eris/lcode.h
    eris/lcorolib.c
    eris/lctype.c
    eris/lctype.h
    eris/ldblib.c
    eris/ldebug.c
    eris/ldebug.h
    eris/ldo.c
    eris/ldo.h
    eris/ldump.c
    eris/lfunc.c
    eris/lfunc.h
    eris/lgc.c
    eris/lgc.h
    eris/linit.c
    eris/liolib.c
    eris/llex.c
    eris/llex.h
    eris/llimits.h
    eris/lmathlib.c
    eris/lmem.c
    eris/lmem.h
    eris/loadlib.c
    eris/lobject.c
    eris/lobject.h
    eris/lopcodes.c
    eris/lopcodes.h
    eris/loslib.c
    eris/lparser.c
    eris/lparser.h
    eris/lprefix.h
    eris/lstate.c
    eris/lstate.h
    eris/lstring.c
    eris/lstring.h
    eris/lstrlib.c
    eris/ltable.c
    eris/ltable.h
    eris/ltablib.c
    eris/ltm.c
    eris/ltm.h
    eris/lua.h
    eris/lua.hpp
    eris/lua.c
    eris/luac.c
    eris/luaconf.h
    eris/lualib.h
    eris/lundump.c
    eris/lundump.h
    eris/lutf8lib.c
    eris/lvm.c
    eris/lvm.h
    eris/lzio.c
    eris/lzio.h
)

wl_library(third_party_gettext
  THIRD_PARTY
  SRCS
    gettext/gettext.h
    gettext/dummy_gettext.cc
)
