=== debian/changelog ===
widelands (2:1.1-4build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:36:05 +1100

widelands (2:1.1-4build3) noble; urgency=medium

  * No-change rebuild against libminizip1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 03:33:29 +0000

widelands (2:1.1-4build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 08:41:41 +0000

widelands (2:1.1-4build1) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 10:27:53 +0100

widelands (2:1.1-4) unstable; urgency=medium

  * d/p/gcc-13.patch: pick an upstream patch to fix FTBFS with gcc 13,
    and complete it (Closes: #1037896).

 -- Martin Quinson <mquinson@debian.org>  Sat, 15 Jul 2023 12:54:33 +0200

widelands (2:1.1-3) unstable; urgency=medium

  * Team upload.
  * Fix version constraint in dir_to_symlink. (Closes: #1033879)

 -- Tobias Frost <tobi@debian.org>  Tue, 04 Apr 2023 16:15:53 +0200

widelands (2:1.1-2) unstable; urgency=medium

  * Team upload.
  * No-change, Source-only upload to allow testing migration.

 -- Tobias Frost <tobi@debian.org>  Tue, 27 Dec 2022 23:29:29 +0100

widelands (2:1.1-1) unstable; urgency=medium

  * New upstream release. From the upstream webpage:
    - Three new scenarios: One each for the Atlantean and Frisian
      campaigns, and a new standalone singleplayer mission
    - An add-ons webserver allows efficient down- and uploading of
      add-ons as well as interactions such as voting and commenting on
      add-ons
    - High-resolution images for many units
    - Multithreading provides smoother performance
    - Multiple enhancements to the in-game encyclopedia
    - Diplomacy: Manage your alliances during the game
    - Fastplace: Assign custom shortcuts to buildings to place them
      with one keystroke
    - In-game loading and restarting of games and scenarios
    - Save and load in-game windows
    - Editor tool history dialog
    - Various AI enhancements
  * Update the debian patches:
    - Merged upstream or cherry-picked from upstream: spelling, gcc12
    - Now useless because upstream only use embedded minizip if not
      installed (#5360, #5392): system-wide_minizip
    - Refresh the other ones so that they apply.
  * d/control: add libasio-dev to the build-deps

 -- Martin Quinson <mquinson@debian.org>  Wed, 26 Oct 2022 12:02:47 +0200

widelands (2:1.0-4) unstable; urgency=medium

  * Team upload.
  * Source only upload.

 -- Tobias Frost <tobi@debian.org>  Tue, 13 Sep 2022 14:41:25 +0200

widelands (2:1.0-3) unstable; urgency=medium

  * Team upload.
  * Properly transit previously shipped font to symlink of packaged font.
    (Closes: #1018966)

 -- Tobias Frost <tobi@debian.org>  Wed, 07 Sep 2022 16:08:33 +0200

widelands (2:1.0-2) unstable; urgency=medium

  * Team upload.
  * Source-only no-change upload to enable migration to testing.

 -- Tobias Frost <tobi@debian.org>  Sat, 27 Aug 2022 13:13:29 +0200

widelands (2:1.0-1) unstable; urgency=medium

  * New upstream release: The 1.0 Release!!
    - Some highlights from the hundreds of changes:
      - A new tribe: the Amazons
      - An add-on system
      - A third frisians scenario
      - Dynamic tribe loading to speed up game loading
      - Targeting individual map objects for removal
      - Mute/unmute messages by buildings
      - Fully redesigned main menu
      - Configurable keyboard shortcuts
      - Enhanced keyboard and mousewheel support in the UI
      - Long-term stable Lua API for game content designers
    - Closes: #992626
  * Update the packaging for this new version
    - Bump the epoch to 2. Version 1:21 was corresponding to build21
      upstream, but now upstream version is 1.0, so bumping the
      epoch is unavoidable.
    - Update d/watch for this new numbering schema (Closes: #1005370)
    - Add a build-dep on libcurl4-gnutls-dev.
    - Refresh patches.
  * Fix lintian overrides
  * Add a patch to fix some spelling issues reported by Lintian

 -- Martin Quinson <mquinson@debian.org>  Tue, 23 Aug 2022 13:19:26 +0200

widelands (1:21-2) unstable; urgency=medium

  [ Stephen Kitt ]
  * Remove Enrico Tassi from uploaders. Closes: #995561.

  [ Martin Quinson ]
  * d/p/gcc-12: Fix FTBFS with gcc-12. Closes: #1013066.
  * Don't depend on fonts-lklug-sinhala as this font is not used anymore.
  * Depend on culmus-fancy to get TaameyFrankCLM fonts.
  - Bump Standards-Version to 4.6.1 -- no changes needed.

 -- Martin Quinson <mquinson@debian.org>  Sun, 14 Aug 2022 23:31:24 +0200

widelands (1:21-1) unstable; urgency=medium

  * New upstream release. Many new features and bugfixes, including:
    - A much stronger AI
    - New “Peaceful Mode” and several new starting conditions
    - Better UI for game speed, map scrolling, and building windows properties
    - New hotkeys
    - Re-added quick navigation with ‘,’ and ‘.’
    - Partly redesigned and modernized user interface
    - Allow the player to choose the soldiers to send in the attack box
    - New planning-ahead ship scheduling algorithm
    - Ferries carry wares over waterways
    - Improved display of work areas
    - Changing settings for buildings in the constructionsite
    - Spritesheets and mipmaps provide high-quality graphics when zooming in
    - Numerous fixes and improvements to the tutorials and scenarios
    - New editor tool to resize the map
    - Lots and lots of balancing tweaks to all tribes
    - Extensive behind-the-scenes source code cleanup and refactoring
    - Support for Big Endian architectures
    - Fully translated to Catalan, Danish, Dutch, Finnish, French,
      Scottish Gaelic, German, Low German, and Spanish, and the translations
      for 9 other languages are more than 2/3 complete.
  * Disable the patches relative to cmake+SDL: upstream fixed the issue.

